package javafxclock;

/**
 * @author Amit
 */

import javafx.scene.Node;
import javafx.scene.CustomNode;
import javafx.scene.Group;
import javafx.scene.geometry.Circle;
import javafx.scene.geometry.Line;
import javafx.application.Frame;
import javafx.application.Stage;
import javafx.scene.paint.Color;
import javafx.scene.transform.Translate;
import javafx.scene.transform.Rotate;
import javafx.animation.Timeline;
import javafx.animation.KeyFrame;
import java.util.Calendar;
import java.lang.System;
import javafx.scene.image.ImageView;
import javafx.scene.image.Image;

var clock : Clock = Clock {};
clock.timer.start();

Frame {
    stage : Stage {
        content : clock
    }
    
    visible : true
    title : "JavaFXClock"
    width : 200
    height : 230
    closeAction : function() { 
        java.lang.System.exit( 0 ); 
    }    
}

public class Clock extends CustomNode {
    
    attribute seconds : Number;
    attribute minutes : Number;
    attribute hours   : Number;
    
    public attribute timer : Timeline = Timeline {
        repeatCount : Timeline.INDEFINITE
        keyFrames : 
            KeyFrame {
                time : 1s
                action : function() {
                    var calendar : Calendar = Calendar.getInstance();
                    seconds = calendar.get( Calendar.SECOND );
                    minutes = calendar.get( Calendar.MINUTE );
                    hours = calendar.get( Calendar.HOUR_OF_DAY );        
                }
            }
    };
    
    public function create(): Node {
        return Group {
            content : [
                ImageView {
                    transform: [ ]
                    image: Image {url: "{__DIR__}/../resources/clock.gif"}
                },                   
                Line {
                    transform : [ Rotate { angle : bind seconds * 6, x : 100, y : 100 }]
                    startX : 100
                    startY : 30
                    endX : 100
                    endY : 100
                    stroke : Color.WHITE
                },
                Line {
                    transform : [ Rotate { angle : bind minutes * 6, x : 100, y : 100 }]
                    startX : 100
                    startY : 40
                    endX : 100
                    endY : 100
                    stroke :Color.LIGHTGRAY
                    strokeWidth : 2
                },
                Line {
                    transform : [ Rotate { angle : bind hours * 30, x : 100, y : 100 }]
                    startX : 100
                    startY : 50
                    endX : 100
                    endY : 100
                    stroke : Color.DARKGRAY
                    strokeWidth : 4
                }            
            ]
        };
    }
}