uniform float pixCoordYOffset;
vec2 pixcoord = vec2(gl_FragCoord.x, pixCoordYOffset-gl_FragCoord.y);
vec4 jsl_sample(sampler2D img, vec2 pos) {
    pos.y = 1.0 - pos.y;
    return texture2D(img, pos);
}
uniform sampler2D baseImg;
uniform float threshold;
void main() {
vec3 luminanceVector = vec3(0.2125, 0.7154, 0.0721);
vec3 val = jsl_sample(baseImg, gl_TexCoord[0].st).rgb;
float luminance = dot(luminanceVector, val);
luminance = max(0.0, luminance - threshold);
gl_FragColor.rgb = val * sign(luminance);
gl_FragColor.a = 1.0;
}
